require ("car")
window = require ("zoom-and-move-window")

local track = require ("track")
local grid = require ("grid")
right_line = track[1]
left_line = track[2]

local w1 = 1
local w2 = 1

function love.load()
	window:load()
	window.translate.x = love.graphics.getWidth( )/2
	window.translate.y = love.graphics.getHeight( )/2
	
	car = vehicle:new()
end


function love.update(dt)
	window:update(dt)
	
	car:update(dt)
end


function love.draw()
	window:draw()
	
	
	
	
	love.graphics.setColor(0.5,0.5,0.5)
	
	love.graphics.setLineWidth( 0.5 )
	love.graphics.lines(grid)
	
	love.graphics.setColor(0.75,0.75,0.75)
	love.graphics.line(-1000, 0, 1000, 0)
	love.graphics.line(0, -1000, 0, 1000)
	
	love.graphics.setColor(0,1,0)
	love.graphics.line(right_line)
	love.graphics.setColor(1,1,0)
	love.graphics.line(left_line)
	

	car:draw()
	
	
	
	-- debug GUI
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	love.graphics.origin()
	love.graphics.setColor(0,1,0)
	love.graphics.print ('Debug GUI:', 1, 0)
	love.graphics.print('x: ' .. mx ..', y: '.. my, 1, 15) 
	love.graphics.print('x: ' .. (mx-window.translate.x)/window.zoom ..
		', y: '.. (my-window.translate.y)/window.zoom, 1, 30) 
	
	love.graphics.print('zoom ' .. window.zoom, 1, 45) 
	love.graphics.print('tr ' .. window.translate.x ..', '.. window.translate.y, 1, 60) 
	love.graphics.print('dscale: ' .. window.dscale , 1, 75)
end


function love.mousepressed(x, y, k)
	window:mousepressed(x, y, k)
end

 
function love.wheelmoved(x, y)
	window:wheelmoved(x, y)
end










